﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Drawing;
using Syncfusion.Windows.Forms.Diagram;

namespace _116118
{
    public partial class _Default : System.Web.UI.Page
    {
        List<Person> Persons = new List<Person>();
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                //Diagram settings            
                DiagramWebControl1.View.Grid.Visible = false;
                DiagramWebControl1.View.BackgroundColor = Color.White;
                DiagramWebControl1.Model.RenderingStyle.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
                DiagramWebControl1.Model.BoundaryConstraintsEnabled = false;
                DiagramWebControl1.Model.SizeToContent = true;
                DiagramWebControl1.Model.LineStyle.LineWidth = 0;
                // Create the Diagram LayoutManager and set it up with the Diagram control
                float spacing = 60.0f;               
                InitializeDiagramData();
                CustomLayoutManager lyt = new CustomLayoutManager(DiagramWebControl1.Model, 0, 70, 50);
                DiagramWebControl1.LayoutManager = lyt;
                lyt.UpdateLayout(null);
                //DiagramWebControl1.LoadBinary(@"..//..//HB_Sample_DiagramBuilder.edd");
            }
        }

        private void InitializeDiagramData()
        {
            Person person1 = new Person();
            person1.Name = "person";
            person1.Role = "xxxxx";
            person1.Address = "no\n land mark, street, City";
            Persons.Add(person1);

            Person person2 = new Person();
            person2.Name = "person";
            person2.Role = "xxxxx";
            person2.Address = "no\n land mark, street, City";
            Persons.Add(person2);

            Person person3 = new Person();
            person3.Name = "person";
            person3.Role = "xxxxx";
            person3.Address = "no\n land mark, street, City";
            Persons.Add(person3);

            Person person4 = new Person();
            person4.Name = "person";
            person4.Role = "xxxxx";
            person4.Address = "no\n land mark, street, City";
            Persons.Add(person4);

            Person person5 = new Person();
            person5.Name = "person";
            person5.Role = "xxxxx";
            person5.Address = "no\n land mark, street, City";
            Persons.Add(person5);

            Person person6 = new Person();
            person6.Name = "person";
            person6.Role = "xxxxx";
            person6.Address = "no\n land mark, street, City";
            Persons.Add(person6);

            Person person7 = new Person();
            person7.Name = "person";
            person7.Role = "xxxxx";
            person7.Address = "no\n land mark, street, City";
            Persons.Add(person7);

            Person person8 = new Person();
            person8.Name = "person";
            person8.Role = "xxxxx";
            person8.Address = "no\n land mark, street, City";
            person8.Photo = new Bitmap(Server.MapPath("~/App_Data/Images/Photo2.png"));
            Persons.Add(person8);

            Person person9 = new Person();
            person9.Name = "person";
            person9.Role = "xxxxx";
            person9.Address = "no\n land mark, street, City";
            person9.Photo = new Bitmap(Server.MapPath("~/App_Data/Images/Photo2.png"));
            Persons.Add(person9);

            Person person10 = new Person();
            person10.Name = "person";
            person10.Role = "xxxxx";
            person10.Address = "no\n land mark, street, City";
            person10.Photo = new Bitmap(Server.MapPath("~/App_Data/Images/Photo2.png"));
            Persons.Add(person10);

            Person person11 = new Person();
            person11.Name = "person";
            person11.Role = "xxxxx";
            person11.Address = "no\n land mark, street, City";
            person11.Photo = new Bitmap(Server.MapPath("~/App_Data/Images/Photo1.png"));
            Persons.Add(person11);

            Person person12 = new Person();
            person12.Name = "person";
            person12.Role = "xxxxx";
            person12.Address = "no\n land mark, street, City";
            Persons.Add(person12);

            Person person13 = new Person();
            person13.Name = "person";
            person13.Role = "xxxxx";
            person13.Address = "no\n land mark, street, City";
            Persons.Add(person13);

            DiagramWebControl1.Model.BeginUpdate();
            int i = 1;
            foreach (Person person in Persons)
            {
                PersonNode personNode = new PersonNode();
                personNode.Title = person.Name;
                personNode.Role = person.Role;
                personNode.Address = person.Address;
                if (person.Photo != null)
                {
                    personNode.Photo = person.Photo;
                    personNode.BackgroundStyle.Color = Color.LightYellow;
                }
                personNode.Name = "person" + i;
                DiagramWebControl1.Model.AppendChild(personNode);
                i++;
            }
            NodeCollection nodes = DiagramWebControl1.Model.Nodes;
            ConnectNodes(nodes["person1"].Ports[0], nodes["person3"].Ports[1]);
            ConnectNodes(nodes["person2"].Ports[0], nodes["person3"].Ports[1]);
            ConnectNodes(nodes["person4"].Ports[0], nodes["person6"].Ports[1]);
            ConnectNodes(nodes["person5"].Ports[0], nodes["person6"].Ports[1]);
            ConnectNodes(nodes["person3"].Ports[2], nodes["person6"].Ports[3]);
            ConnectNodes(nodes["person3"].Ports[0], nodes["person7"].Ports[1]);
            ConnectNodes(nodes["person6"].Ports[0], nodes["person7"].Ports[1]);
            ConnectNodes(nodes["person7"].Ports[0], nodes["person8"].Ports[1]);
            ConnectNodes(nodes["person7"].Ports[0], nodes["person9"].Ports[1]);
            ConnectNodes(nodes["person7"].Ports[0], nodes["person10"].Ports[1]);
            ConnectNodes(nodes["person10"].Ports[0], nodes["person11"].Ports[1]);
            ConnectNodes(nodes["person7"].Ports[0], nodes["person12"].Ports[1]);
            ConnectNodes(nodes["person10"].Ports[0], nodes["person13"].Ports[1]);

            CustomLayoutManager lyt = new CustomLayoutManager(DiagramWebControl1.Model, 0, 70, 50);
            DiagramWebControl1.LayoutManager = lyt;
            lyt.UpdateLayout(null);
            DiagramWebControl1.Model.EndUpdate();

        }
        private void ConnectNodes(ConnectionPoint parentPort, ConnectionPoint childPort)
        {
            OrgLineConnector link = new OrgLineConnector(PointF.Empty, new PointF(0, 1));
            link.EditStyle.AllowSelect = false;
            DiagramWebControl1.Model.AppendChild(link);
            parentPort.Connect(link.TailEndPoint);
            childPort.Connect(link.HeadEndPoint);
            DiagramWebControl1.Model.SendToBack(link);
            DiagramWebControl1.View.SelectionList.Clear();
        }
    }
}
